#pragma once

#include "opener_context_object_interface.h"
#include "simple_pager.h"



/* Forward declaration. */

class OpenerResource;



/* Support for indicating files to be opened. */

class OpenerContextResource : public SimplePager, public OpenerContextObject
{
protected:
    OpenerResource *_opener;

public:
    explicit OpenerContextResource(OpenerResource *opener, Memory *memory=NULL);

    /* Server details. */

    int expected_items();

    ipc_server_handler_type handler();

    void *interface()
    { return static_cast<OpenerContextObject *>(this); }

    /* Data access methods. */

    char *get_path();

    /* Opener context interface methods. */

    long open(flags_t flags, offset_t *size, l4_cap_idx_t *file);

    /* Pager/dataspace methods. */

    long map(unsigned long offset, address_t hot_spot, flags_t flags,
             l4_snd_fpage_t *region)
    { return SimplePager::map(offset, hot_spot, flags, region); }

    long info(unsigned long *size, unsigned long *flags)
    { return SimplePager::info(size, flags); }
};

// vim: tabstop=4 expandtab shiftwidth=4
